'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bootstrap = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _bluebird = require('bluebird');

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

require('../../utils/register');

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _knex = require('knex');

var _knex2 = _interopRequireDefault(_knex);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _process$env$DATABASE = process.env.DATABASE_URL.match(/(.*):\/\/\/?(.*)/),
    _process$env$DATABASE2 = (0, _slicedToArray3.default)(_process$env$DATABASE, 2),
    connection = _process$env$DATABASE2[0],
    protocol = _process$env$DATABASE2[1];

var knex = new _knex2.default({
  client: protocol === 'postgres' ? 'postgresql' : protocol,
  connection: connection,
  useNullAsDefault: true,
  pool: {
    min: 1,
    max: 1
  }
});

var bootstrap = exports.bootstrap = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name, message) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return bootstrapApps();

          case 2:
            _context.next = 4;
            return bootstrapType('alerts', 'maha_alerts');

          case 4:
            _context.next = 6;
            return bootstrapType('notifications', 'maha_notification_types');

          case 6:
            _context.next = 8;
            return bootstrapType('rights', 'maha_rights');

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function bootstrap(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var bootstrapApps = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var objects, items, addItems;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            objects = _glob2.default.sync('apps/*/src/app.js').map(function (file) {
              return require(_path2.default.resolve(file)).default;
            });
            _context2.next = 3;
            return knex('maha_apps');

          case 3:
            items = _context2.sent;
            addItems = objects.filter(function (object) {
              return object.code !== 'maha' && _lodash2.default.find(items, { code: object.code }) === undefined;
            });
            _context2.next = 7;
            return knex('maha_apps').insert(addItems.map(function (item) {
              return {
                code: item.code
              };
            }));

          case 7:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function bootstrapApps() {
    return _ref2.apply(this, arguments);
  };
}();

var bootstrapType = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(type, table) {
    var objects, items, addItems;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return collectObjects('admin/' + type);

          case 2:
            objects = _context3.sent;
            _context3.next = 5;
            return knex(table);

          case 5:
            items = _context3.sent;
            addItems = objects.filter(function (object) {
              return _lodash2.default.find(items, { code: object.code }) === undefined;
            });
            _context3.next = 9;
            return knex(table).insert(addItems.map(function (item) {
              return {
                app_id: item.app_id,
                code: item.code
              };
            }));

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function bootstrapType(_x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();

var collectObjects = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(pattern) {
    var items;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            items = _glob2.default.sync('apps/*/src/' + pattern + '.js');
            _context5.next = 3;
            return (0, _bluebird.reduce)(items, function () {
              var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(objects, file) {
                var _file$match, _file$match2, appPath, config, app;

                return _regenerator2.default.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _file$match = file.match(/apps\/([^/]*)/), _file$match2 = (0, _slicedToArray3.default)(_file$match, 2), appPath = _file$match2[1];
                        config = require(_path2.default.resolve('apps/' + appPath + '/src/app.js')).default;
                        _context4.next = 4;
                        return knex('maha_apps').where({
                          code: config.code
                        });

                      case 4:
                        app = _context4.sent;
                        return _context4.abrupt('return', [].concat((0, _toConsumableArray3.default)(objects), (0, _toConsumableArray3.default)(require(_path2.default.resolve(file)).default.map(function (item) {
                          return (0, _extends3.default)({}, item, {
                            app_id: app[0] ? app[0].id : null
                          });
                        }))));

                      case 6:
                      case 'end':
                        return _context4.stop();
                    }
                  }
                }, _callee4, undefined);
              }));

              return function (_x6, _x7) {
                return _ref5.apply(this, arguments);
              };
            }(), []);

          case 3:
            return _context5.abrupt('return', _context5.sent);

          case 4:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function collectObjects(_x5) {
    return _ref4.apply(this, arguments);
  };
}();