"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var chunkTest = exports.chunkTest = function chunkTest(module) {
  if (!module.nameForCondition) return false;
  var name = module.nameForCondition();
  var is_filetype = name.match(/\.js$/) !== null;
  return is_filetype && !isMahaModule(name);
};

var ruleTest = exports.ruleTest = function ruleTest(test) {
  return function (name) {
    var is_filetype = name.match(test) !== null;
    return is_filetype && isMahaModule(name);
  };
};

var isMahaModule = exports.isMahaModule = function isMahaModule(name) {
  var is_not_submodule = name.match(/(packages|node_modules)\/[^/]*\/node_modules/) === null;
  var is_app = name.match(/apps/) !== null;
  var is_reframe = name.match(/reframe/) !== null;
  var is_tmp = name.match(/tmp/) !== null;
  return is_not_submodule && (is_app || is_reframe || is_tmp);
};