'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rollbackTransaction = exports.beginTransaction = exports.teardownTestDb = exports.setupTestDb = exports.loadSeeds = exports.loadFixtures = exports.reset = exports.migrateDown = exports.migrateUp = undefined;

var _bluebird = require('bluebird');

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends8 = require('babel-runtime/helpers/extends');

var _extends9 = _interopRequireDefault(_extends8);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

require('../../utils/register');

var _console = require('../../utils/console');

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _knex = require('knex');

var _knex2 = _interopRequireDefault(_knex);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _process$env$DATABASE = process.env.DATABASE_URL.match(/(.*):\/\/\/?(.*)/),
    _process$env$DATABASE2 = (0, _slicedToArray3.default)(_process$env$DATABASE, 2),
    connection = _process$env$DATABASE2[0],
    protocol = _process$env$DATABASE2[1];

var knex = new _knex2.default({
  client: protocol === 'postgres' ? 'postgresql' : protocol,
  connection: connection,
  useNullAsDefault: true,
  pool: {
    min: 1,
    max: 1
  }
});

var migrateUp = exports.migrateUp = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _migrate('up');

          case 2:
            return _context.abrupt('return', _context.sent);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function migrateUp() {
    return _ref.apply(this, arguments);
  };
}();

var migrateDown = exports.migrateDown = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _migrate('down');

          case 2:
            return _context2.abrupt('return', _context2.sent);

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function migrateDown() {
    return _ref2.apply(this, arguments);
  };
}();

var reset = exports.reset = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _reset();

          case 2:
            return _context3.abrupt('return', _context3.sent);

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function reset() {
    return _ref3.apply(this, arguments);
  };
}();

var loadFixtures = exports.loadFixtures = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return _loadData('fixtures');

          case 2:
            return _context4.abrupt('return', _context4.sent);

          case 3:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function loadFixtures() {
    return _ref4.apply(this, arguments);
  };
}();

var loadSeeds = exports.loadSeeds = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return _loadData('seeds');

          case 2:
            return _context5.abrupt('return', _context5.sent);

          case 3:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function loadSeeds() {
    return _ref5.apply(this, arguments);
  };
}();

var setupTestDb = exports.setupTestDb = function () {
  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return migrateDown().then(migrateUp).then(loadFixtures);

          case 2:
            return _context6.abrupt('return', _context6.sent);

          case 3:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, undefined);
  }));

  return function setupTestDb() {
    return _ref6.apply(this, arguments);
  };
}();

var teardownTestDb = exports.teardownTestDb = function () {
  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return migrateDown();

          case 2:
            return _context7.abrupt('return', _context7.sent);

          case 3:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function teardownTestDb() {
    return _ref7.apply(this, arguments);
  };
}();

var beginTransaction = exports.beginTransaction = function beginTransaction() {
  return knex.raw('BEGIN TRANSACTION');
};

var rollbackTransaction = exports.rollbackTransaction = function rollbackTransaction() {
  return knex.raw('ROLLBACK TRANSACTION');
};

var _migrate = function () {
  var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(direction) {
    var appPaths, allMigrations, migrations;
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return _findOrCreateSchema();

          case 2:
            appPaths = _getAppPaths();
            allMigrations = _getMigrations(appPaths);
            _context8.next = 6;
            return _filterScripts(allMigrations, direction);

          case 6:
            migrations = _context8.sent;
            _context8.next = 9;
            return _runMigrations(migrations, direction);

          case 9:
            if (!(direction === 'down')) {
              _context8.next = 12;
              break;
            }

            _context8.next = 12;
            return _dropSchema();

          case 12:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function _migrate(_x) {
    return _ref8.apply(this, arguments);
  };
}();

var _reset = function () {
  var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return _migrate('down', null);

          case 2:
            _context9.next = 4;
            return _migrate('up', null);

          case 4:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, undefined);
  }));

  return function _reset() {
    return _ref9.apply(this, arguments);
  };
}();

var _hasScriptBeenRun = function () {
  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(migration) {
    var result, response, count;
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _context10.next = 2;
            return knex('schema_migrations').count('* as count').where({ migration: migration });

          case 2:
            result = _context10.sent;
            response = result.rows ? result.rows[0] : result[0];
            count = response.count ? parseInt(response.count) : 0;
            return _context10.abrupt('return', count !== 0);

          case 6:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, undefined);
  }));

  return function _hasScriptBeenRun(_x2) {
    return _ref10.apply(this, arguments);
  };
}();

var _findOrCreateSchema = function () {
  var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11() {
    return _regenerator2.default.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            _context11.next = 2;
            return knex.schema.createTableIfNotExists('schema_migrations', function (table) {
              return table.string('migration');
            });

          case 2:
            return _context11.abrupt('return', _context11.sent);

          case 3:
          case 'end':
            return _context11.stop();
        }
      }
    }, _callee11, undefined);
  }));

  return function _findOrCreateSchema() {
    return _ref11.apply(this, arguments);
  };
}();

var _dropSchema = function () {
  var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12() {
    return _regenerator2.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _context12.next = 2;
            return knex.schema.dropTableIfExists('schema_migrations');

          case 2:
            return _context12.abrupt('return', _context12.sent);

          case 3:
          case 'end':
            return _context12.stop();
        }
      }
    }, _callee12, undefined);
  }));

  return function _dropSchema() {
    return _ref12.apply(this, arguments);
  };
}();

var _runMigrations = function _runMigrations(migrations, direction) {

  return (0, _bluebird.mapSeries)(migrations, function () {
    var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee14(migration) {
      return _regenerator2.default.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              _context14.next = 2;
              return knex.transaction(function () {
                var _ref14 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13(trx) {
                  var runner;
                  return _regenerator2.default.wrap(function _callee13$(_context13) {
                    while (1) {
                      switch (_context13.prev = _context13.next) {
                        case 0:
                          runner = require(migration.path).default;

                          if (!(direction === 'up')) {
                            _context13.next = 8;
                            break;
                          }

                          _context13.next = 4;
                          return runner.up(trx);

                        case 4:
                          _context13.next = 6;
                          return _recordMigration(migration.name, trx);

                        case 6:
                          _context13.next = 12;
                          break;

                        case 8:
                          _context13.next = 10;
                          return runner.down(trx);

                        case 10:
                          _context13.next = 12;
                          return _removeMigration(migration.name, trx);

                        case 12:

                          _log(_chalk2.default.grey(migration.name), _chalk2.default.green('✔'), true, true);

                        case 13:
                        case 'end':
                          return _context13.stop();
                      }
                    }
                  }, _callee13, undefined);
                }));

                return function (_x4) {
                  return _ref14.apply(this, arguments);
                };
              }());

            case 2:
            case 'end':
              return _context14.stop();
          }
        }
      }, _callee14, undefined);
    }));

    return function (_x3) {
      return _ref13.apply(this, arguments);
    };
  }());
};

var _recordMigration = function _recordMigration(migration, trx) {

  return trx('schema_migrations').insert({ migration: migration });
};

var _removeMigration = function _removeMigration(migration, trx) {

  return trx('schema_migrations').where({ migration: migration }).delete();
};

var _filterScripts = function () {
  var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee17(scripts, direction) {
    return _regenerator2.default.wrap(function _callee17$(_context17) {
      while (1) {
        switch (_context17.prev = _context17.next) {
          case 0:
            if (!(direction === 'down')) {
              _context17.next = 6;
              break;
            }

            _context17.next = 3;
            return (0, _bluebird.filter)(scripts.reverse(), function () {
              var _ref16 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee15(script) {
                return _regenerator2.default.wrap(function _callee15$(_context15) {
                  while (1) {
                    switch (_context15.prev = _context15.next) {
                      case 0:
                        _context15.next = 2;
                        return _hasScriptBeenRun(script.name);

                      case 2:
                        return _context15.abrupt('return', _context15.sent);

                      case 3:
                      case 'end':
                        return _context15.stop();
                    }
                  }
                }, _callee15, undefined);
              }));

              return function (_x7) {
                return _ref16.apply(this, arguments);
              };
            }());

          case 3:
            return _context17.abrupt('return', _context17.sent);

          case 6:
            _context17.next = 8;
            return (0, _bluebird.filter)(scripts, function () {
              var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee16(script) {
                return _regenerator2.default.wrap(function _callee16$(_context16) {
                  while (1) {
                    switch (_context16.prev = _context16.next) {
                      case 0:
                        _context16.next = 2;
                        return _hasScriptBeenRun(script.name);

                      case 2:
                        _context16.t0 = _context16.sent;
                        return _context16.abrupt('return', _context16.t0 === false);

                      case 4:
                      case 'end':
                        return _context16.stop();
                    }
                  }
                }, _callee16, undefined);
              }));

              return function (_x8) {
                return _ref17.apply(this, arguments);
              };
            }());

          case 8:
            return _context17.abrupt('return', _context17.sent);

          case 9:
          case 'end':
            return _context17.stop();
        }
      }
    }, _callee17, undefined);
  }));

  return function _filterScripts(_x5, _x6) {
    return _ref15.apply(this, arguments);
  };
}();

var _loadData = function () {
  var _ref18 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee21(type) {
    var appPaths, allFixtures, merged, withIds, interpolated;
    return _regenerator2.default.wrap(function _callee21$(_context21) {
      while (1) {
        switch (_context21.prev = _context21.next) {
          case 0:
            appPaths = _getAppPaths();
            allFixtures = _getFixtures(appPaths, type);
            merged = _mergeFixtures(allFixtures);
            withIds = _assignIds(merged);
            _context21.next = 6;
            return _renderFixtures(withIds);

          case 6:
            interpolated = _context21.sent;
            _context21.next = 9;
            return (0, _bluebird.mapSeries)(Object.keys(interpolated), function () {
              var _ref19 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee20(tableName) {
                return _regenerator2.default.wrap(function _callee20$(_context20) {
                  while (1) {
                    switch (_context20.prev = _context20.next) {
                      case 0:
                        _context20.next = 2;
                        return knex.transaction(function () {
                          var _ref20 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee19(trx) {
                            var records, chunks, idColumn;
                            return _regenerator2.default.wrap(function _callee19$(_context19) {
                              while (1) {
                                switch (_context19.prev = _context19.next) {
                                  case 0:

                                    _log(_chalk2.default.grey(tableName));

                                    if (!(knex.client.config.client === 'postgresql')) {
                                      _context19.next = 4;
                                      break;
                                    }

                                    _context19.next = 4;
                                    return trx.raw('set session_replication_role = replica');

                                  case 4:
                                    _context19.next = 6;
                                    return trx(tableName).del();

                                  case 6:
                                    records = interpolated[tableName];
                                    chunks = _lodash2.default.chunk(records, 50);
                                    _context19.next = 10;
                                    return (0, _bluebird.mapSeries)(chunks, function () {
                                      var _ref21 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee18(chunk) {
                                        return _regenerator2.default.wrap(function _callee18$(_context18) {
                                          while (1) {
                                            switch (_context18.prev = _context18.next) {
                                              case 0:
                                                _context18.next = 2;
                                                return trx(tableName).insert(chunk);

                                              case 2:
                                                return _context18.abrupt('return', _context18.sent);

                                              case 3:
                                              case 'end':
                                                return _context18.stop();
                                            }
                                          }
                                        }, _callee18, undefined);
                                      }));

                                      return function (_x12) {
                                        return _ref21.apply(this, arguments);
                                      };
                                    }()).catch(console.log);

                                  case 10:
                                    _context19.prev = 10;

                                    if (!(knex.client.config.client === 'postgresql')) {
                                      _context19.next = 18;
                                      break;
                                    }

                                    _context19.next = 14;
                                    return trx.raw('SELECT column_name FROM information_schema.columns WHERE table_name=\'' + tableName + '\' and column_name=\'id\'');

                                  case 14:
                                    idColumn = _context19.sent;

                                    if (!(idColumn.rowCount > 0)) {
                                      _context19.next = 18;
                                      break;
                                    }

                                    _context19.next = 18;
                                    return trx.raw('SELECT pg_catalog.setval(pg_get_serial_sequence(\'' + tableName + '\', \'id\'), MAX(id)) FROM ' + tableName);

                                  case 18:
                                    _context19.next = 22;
                                    break;

                                  case 20:
                                    _context19.prev = 20;
                                    _context19.t0 = _context19['catch'](10);

                                  case 22:
                                    if (!(trx.client.config.client === 'postgresql')) {
                                      _context19.next = 25;
                                      break;
                                    }

                                    _context19.next = 25;
                                    return trx.raw('set session_replication_role = default');

                                  case 25:

                                    _log(_chalk2.default.grey(tableName), _chalk2.default.green('✔'), true, true);

                                  case 26:
                                  case 'end':
                                    return _context19.stop();
                                }
                              }
                            }, _callee19, undefined, [[10, 20]]);
                          }));

                          return function (_x11) {
                            return _ref20.apply(this, arguments);
                          };
                        }());

                      case 2:
                      case 'end':
                        return _context20.stop();
                    }
                  }
                }, _callee20, undefined);
              }));

              return function (_x10) {
                return _ref19.apply(this, arguments);
              };
            }());

          case 9:
          case 'end':
            return _context21.stop();
        }
      }
    }, _callee21, undefined);
  }));

  return function _loadData(_x9) {
    return _ref18.apply(this, arguments);
  };
}();

// load all fixtures from across apps, and merge all data into a single
// nested hash
var _mergeFixtures = function _mergeFixtures(files) {

  return files.reduce(function (merged, file) {
    var _require$default = require(file.path).default,
        tableName = _require$default.tableName,
        records = _require$default.records;

    return (0, _extends9.default)({}, merged, (0, _defineProperty3.default)({}, tableName, _lodash2.default.isArray(records) ? [].concat((0, _toConsumableArray3.default)(merged[tableName] || []), (0, _toConsumableArray3.default)(records)) : (0, _extends9.default)({}, merged[tableName], records)));
  }, {});
};

// loop through all fixtures from each table and preemtively assign an id,
// creating a map for lookups
var _assignIds = function _assignIds(data) {

  return Object.keys(data).reduce(function (tables, tableName) {

    var fixtures = data[tableName];

    if (_lodash2.default.isArray(fixtures)) {

      return (0, _extends9.default)({}, tables, (0, _defineProperty3.default)({}, tableName, fixtures));
    }

    var withIds = Object.keys(fixtures).reduce(function (withIds, name, index) {
      return (0, _extends9.default)({}, withIds, (0, _defineProperty3.default)({}, name, {
        id: index + 1,
        values: fixtures[name]
      }));
    }, {});

    return (0, _extends9.default)({}, tables, (0, _defineProperty3.default)({}, tableName, withIds));
  }, {});
};

// loop through all fixtures and call the function with the data hash, allowing
// each fixture to interpolate ids from orher named fixtures
var _renderFixtures = function _renderFixtures(data) {

  return (0, _bluebird.reduce)(Object.keys(data), function () {
    var _ref22 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee22(tables, tableName) {
      var columns, fixtures, interpolated;
      return _regenerator2.default.wrap(function _callee22$(_context22) {
        while (1) {
          switch (_context22.prev = _context22.next) {
            case 0:
              _context22.next = 2;
              return knex(tableName).columnInfo();

            case 2:
              columns = _context22.sent;
              fixtures = data[tableName];

              if (!_lodash2.default.isArray(fixtures)) {
                _context22.next = 6;
                break;
              }

              return _context22.abrupt('return', (0, _extends9.default)({}, tables, (0, _defineProperty3.default)({}, tableName, fixtures)));

            case 6:
              interpolated = Object.keys(fixtures).reduce(function (interpolated, name) {

                var fixtureData = _renderFixture(tableName, fixtures, name, data);

                if (columns.id) {

                  return [].concat((0, _toConsumableArray3.default)(interpolated), [(0, _extends9.default)({
                    id: fixtures[name].id
                  }, fixtureData)]);
                }

                return [].concat((0, _toConsumableArray3.default)(interpolated), [fixtureData]);
              }, []);
              return _context22.abrupt('return', (0, _extends9.default)({}, tables, (0, _defineProperty3.default)({}, tableName, interpolated)));

            case 8:
            case 'end':
              return _context22.stop();
          }
        }
      }, _callee22, undefined);
    }));

    return function (_x13, _x14) {
      return _ref22.apply(this, arguments);
    };
  }(), {});
};

var _renderFixture = function _renderFixture(tableName, fixtures, name, data) {

  try {

    return fixtures[name].values(data);
  } catch (err) {

    throw new Error('Unable to load fixture data for \'' + name + '\' in \'' + tableName + '\' (' + err.message + ')');
  }
};

var _getMigrations = function _getMigrations(appPaths) {
  return _getSortedFiles(appPaths, 'migrations');
};

var _getFixtures = function _getFixtures(appPaths, type) {
  return _getSortedFiles(appPaths, type);
};

var _getSortedFiles = function _getSortedFiles(appPaths, targetPath) {

  var sorted = _lodash2.default.castArray(appPaths).reduce(function (files, appPath) {

    var dbPath = _path2.default.join(appPath, 'db');

    var fullTargetPath = _path2.default.join(dbPath, targetPath);

    if (!_fs2.default.existsSync(fullTargetPath)) return files;

    return [].concat((0, _toConsumableArray3.default)(files), (0, _toConsumableArray3.default)(_fs2.default.readdirSync(fullTargetPath).map(function (name) {

      var matches = name.match(/(\d{13}).*/);

      return (0, _extends9.default)({
        name: name,
        path: _path2.default.join(fullTargetPath, name)
      }, matches ? { timestamp: matches[1] } : {});
    })));
  }, []).filter(function (file) {

    return !_lodash2.default.isNil(file.name.match(/.*\.js$/));
  }).sort(function (first, second) {

    if (first.name < second.name) return -1;

    if (first.name > second.name) return 1;

    return 0;
  });

  return sorted;
};

var _getAppPaths = function _getAppPaths() {

  return process.env.APPS.split(',').map(function (app) {
    return _path2.default.resolve('apps', app, 'src');
  });
};

var _log = function _log(label) {
  var text = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var newline = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var rewind = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;


  if (process.env.NODE_ENV === 'test') return;

  (0, _console.writePaddedLine)(label, text, '#FFFFFF', newline, rewind);
};