'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _task = require('../../objects/task');

var _task2 = _interopRequireDefault(_task);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Db = [(0, _task2.default)({
  command: 'db:migrate:up',
  description: 'Running up migrations',
  file: _path2.default.resolve(__dirname, 'db'),
  function: 'migrateUp'
}), (0, _task2.default)({
  command: 'db:migrate:down',
  description: 'Running down migrations',
  file: _path2.default.resolve(__dirname, 'db'),
  function: 'migrateDown'
}), (0, _task2.default)({
  command: 'db:migrate:reset',
  description: 'Resetting database',
  file: _path2.default.resolve(__dirname, 'db'),
  function: 'reset'
}), (0, _task2.default)({
  command: 'db:fixtures:load',
  description: 'Loading test fixtures',
  file: _path2.default.resolve(__dirname, 'db'),
  function: 'loadFixtures'
}), (0, _task2.default)({
  command: 'db:seeds:load',
  description: 'Loading seeds',
  file: _path2.default.resolve(__dirname, 'db'),
  function: 'loadSeeds'
})];

exports.default = Db;