'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dev = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends5 = require('babel-runtime/helpers/extends');

var _extends6 = _interopRequireDefault(_extends5);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _console = require('../../utils/console');

var _webpackDevServer = require('webpack-dev-server');

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _child_process = require('child_process');

var _webpack = require('./webpack.client');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = require('webpack');

var _webpack4 = _interopRequireDefault(_webpack3);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var apps = process.env.APPS.split(',');

var serverWatch = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var nodemon, proc;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            nodemon = [_path2.default.resolve('scripts', 'dev.js'), '--color', '--quiet', '--exec', 'node'];

            _fs2.default.readdirSync('apps').map(function (app) {
              nodemon.push('--watch');
              nodemon.push(_path2.default.resolve('apps', app, 'src'));
              nodemon.push('--ignore');
              nodemon.push(_path2.default.resolve('apps', app, 'src', 'admin', 'components'));
              nodemon.push('--ignore');
              nodemon.push(_path2.default.resolve('apps', app, 'src', 'admin', 'views'));
            });
            _fs2.default.readdirSync('packages').map(function (pkg) {
              nodemon.push('--watch');
              nodemon.push(_path2.default.resolve('packages', pkg, 'src'));
            });

            proc = (0, _child_process.spawn)('nodemon', nodemon, {
              stdio: ['pipe', 'pipe', 'pipe', 'ipc']
            });


            proc.on('message', function (event) {
              if (event.type === 'start') {
                (0, _console.info)('DEV', 'Compiling servers');
              } else if (event.type === 'restart') {
                (0, _console.info)('DEV', 'Detected change in ' + event.data[0]);
              }
            });

            proc.stdout.on('data', function (data) {
              (0, _console.write)(data);
            });

            proc.stderr.on('data', function (err) {
              (0, _console.error)('DEV', err.toString());
            });

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function serverWatch() {
    return _ref.apply(this, arguments);
  };
}();

var dev = exports.dev = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(flags, args) {
    var contentBase, server, devserver;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return serverWatch();

          case 2:
            contentBase = _path2.default.resolve('apps', 'maha', 'src', 'admin', 'public');
            server = 'http://localhost:' + process.env.SERVER_PORT;
            devserver = new _webpackDevServer2.default((0, _webpack4.default)((0, _webpack2.default)(apps)), {
              contentBase: contentBase,
              hot: true,
              publicPath: '/admin',
              proxy: (0, _extends6.default)({}, 'api/,jobs/,imagecache/,.well-known/,mailbox_mime/,v,c,ns,so'.split(',').reduce(function (proxies, path) {
                return (0, _extends6.default)({}, proxies, (0, _defineProperty3.default)({}, '/' + path + '*', server));
              }, {}), 'html,json'.split(',').reduce(function (proxies, ext) {
                return (0, _extends6.default)({}, proxies, (0, _defineProperty3.default)({}, '/admin/*.' + ext, server));
              }, {}), 'audio,css,fonts,images,js'.split(',').reduce(function (proxies, path) {
                return (0, _extends6.default)({}, proxies, (0, _defineProperty3.default)({}, '/admin/' + path + '/*', server));
              }, {})),
              quiet: true,
              historyApiFallback: {
                disableDotRule: true,
                rewrites: [{ from: /.*/, to: '/admin' }]
              }
            });


            devserver.listen(process.env.DEVSERVER_PORT);

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function dev(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();