'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require('bluebird');

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends5 = require('babel-runtime/helpers/extends');

var _extends6 = _interopRequireDefault(_extends5);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promptPromise = require('prompt-promise');

var _promptPromise2 = _interopRequireDefault(_promptPromise);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
  var data;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return readData();

        case 2:
          data = _context.sent;
          _context.next = 5;
          return collectData(data);

        case 5:
          data = _context.sent;


          writeFile(data);

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}));


var filePath = _path2.default.resolve('.', '.env');

var variables = [{ label: 'DATABASE_URL', default: 'sqlite3://:memory' }, { label: 'REDIS_URL', default: 'redis://localhost:6379/13' }, { label: 'SECRET', default: 'foo' }, { label: 'SERVER_PORT', default: '8080' }, { label: 'WORKER_PORT', default: '8081' }, { label: 'DOMAIN', default: 'localhost' }, { label: 'AWS_ACCESS_KEY_ID' }, { label: 'AWS_SECRET_ACCESS_KEY' }, { label: 'AWS_REGION' }, { label: 'AWS_BUCKET' }, { label: 'WEB_HOST' }, { label: 'WEB_ASSET_HOST' }, { label: 'DATA_ASSET_HOST' }, { label: 'WEB_ASSET_CDN_HOST' }, { label: 'DATA_ASSET_CDN_HOST' }];

var readData = function readData() {

  if (!_fs2.default.existsSync(filePath)) return getDefaults();

  var data = _fs2.default.readFileSync(filePath).toString().split('\n').reduce(function (values, line) {

    var matches = line.match(/([A-Z_]*)=(.*)/);

    if (!matches) return values;

    var _matches = (0, _slicedToArray3.default)(matches, 3),
        key = _matches[1],
        value = _matches[2];

    return (0, _extends6.default)({}, values, (0, _defineProperty3.default)({}, key, value));
  }, {});

  return (0, _bluebird.resolve)(data);
};

var collectData = function collectData(defaults) {

  return (0, _bluebird.reduce)(variables, function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(data, variable) {
      var defaultValue, value;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              defaultValue = defaults[variable.label];
              _context2.next = 3;
              return (0, _promptPromise2.default)(variable.label + ' [' + _chalk2.default.grey(defaultValue) + ']: ');

            case 3:
              value = _context2.sent;
              return _context2.abrupt('return', (0, _extends6.default)({}, data, (0, _defineProperty3.default)({}, '' + variable.label, value || defaultValue)));

            case 5:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }(), {});
};

var writeFile = function writeFile(data) {

  var fileData = Object.keys(data).map(function (key) {
    return key + '=' + data[key];
  }).join('\n');

  return _fs2.default.writeFileSync(filePath, fileData);
};

var getDefaults = function getDefaults() {

  var defaults = variables.reduce(function (defaults, variable) {
    return (0, _extends6.default)({}, defaults, (0, _defineProperty3.default)({}, variable.label, variable.default || ''));
  }, {});

  return defaults;
};