'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retryJob = exports.queueClean = exports.queueAdd = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _collect_objects = require('../../utils/collect_objects');

var _collect_objects2 = _interopRequireDefault(_collect_objects);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var queueFiles = (0, _collect_objects2.default)('queues/*');

var _getQueue = function _getQueue(namespace) {

  var config = _lodash2.default.find(queueFiles, { namespace: namespace });

  if (!config) throw new Error('invalid queue');

  var queue = require(config.filepath).default;

  if (!queue) throw new Error('invalid queue');

  return queue;
};

var queueAdd = exports.queueAdd = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(namespace, jobString) {
    var queue, job;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            queue = _getQueue(namespace);
            job = JSON.parse(jobString);
            _context.next = 4;
            return queue.enqueue(null, null, job);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function queueAdd(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var queueClean = exports.queueClean = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(namespace) {
    var queue;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            queue = _getQueue(namespace);
            _context2.next = 3;
            return queue.clean('active');

          case 3:
            _context2.next = 5;
            return queue.clean('wait');

          case 5:
            _context2.next = 7;
            return queue.clean('delayed');

          case 7:
            _context2.next = 9;
            return queue.clean('failed');

          case 9:
            _context2.next = 11;
            return queue.clean('completed');

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function queueClean(_x3) {
    return _ref2.apply(this, arguments);
  };
}();

var retryJob = exports.retryJob = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(namespace, job_id) {
    var queue, job;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            queue = _getQueue(namespace);
            _context3.next = 3;
            return queue.getJob(job_id);

          case 3:
            job = _context3.sent;
            _context3.next = 6;
            return job.retry();

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function retryJob(_x4, _x5) {
    return _ref3.apply(this, arguments);
  };
}();