import generator from '../../objects/generator'

const App = generator({
  files: [
    {
      action: 'create',
      filepath: 'src/admin/components/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/api/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/views/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/api.js',
      template: 'api.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/navigation.js',
      template: 'navigation.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/rights.js',
      template: 'rights.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/routes.js',
      template: 'routes.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/search.js',
      template: 'search.ejs'
    }, {
      action: 'create',
      filepath: 'src/admin/style.less',
      template: 'style.ejs'
    }, {
      action: 'create',
      filepath: 'src/cron/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/db/fixtures/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/db/migrations/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/db/seeds/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/emails/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/models/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/mailboxes/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/public/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/queues/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/serializers/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tasks/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/admin_api/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/admin_components/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/admin_views/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/base/tests.js',
      template: 'tests.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/cron/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/email/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/models/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/mailboxes/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/public_api/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/public_components/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/public_views/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/queues/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/serializers/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/tests/tasks/.gitkeep',
      template: 'gitkeep.ejs'
    }, {
      action: 'create',
      filepath: 'src/app.js',
      template: 'app.ejs'
    }, {
      action: 'create',
      filepath: 'package.json',
      template: 'package.ejs'
    }, {
      action: 'create',
      filepath: '.babelrc',
      template: 'babelrc.ejs'
    }, {
      action: 'create',
      filepath: '.eslintignore',
      template: 'eslintignore.ejs'
    }, {
      action: 'create',
      filepath: '.eslintrc.json',
      template: 'eslintrc.ejs'
    }, {
      action: 'create',
      filepath: '.gitignore',
      template: 'gitignore.ejs'
    }, {
      action: 'create',
      filepath: 'README.md',
      template: 'readme.ejs'
    }
  ],
  after: [
    {
      description: 'installing node modules',
      command: 'npm install'
    }, {
      description: 'building source',
      command: 'npm run build'
    }
  ]
})

export default App
