#!/usr/bin/env node

import './utils/environment'
import { help, run } from './utils/cli'
import minimist from 'minimist'
import _ from 'lodash'

const parse = (args) => {

  const argv = minimist(args)

  return {
    command: argv._[0],
    args: argv._.slice(1),
    help: argv.help !== undefined,
    flags: _.omit(argv, ['help', '_'])
  }

}

const execute = async (argv) => {

  const parsed = parse(argv)

  if(parsed.help || !parsed.command) return help(parsed.command)

  await run(parsed)

}

execute(process.argv.slice(2))
