import chalk from 'chalk'
import _ from 'lodash'

const task = (options) => {

  const exit = !_.isNil(options.exit) ? options.exit : true

  const newline = !_.isNil(options.newline) ? options.newline : true

  const action = async (flags, args) => {

    try {

      const source = require(options.file)

      await source[options.function](flags, args)

      if(newline) process.stdout.write('\n')

      if(exit) process.exit()

    } catch(err) {

      console.log(chalk.red(err.message))

      process.exit()

    }

  }

  return {
    command: options.command,
    description: options.description,
    alias: options.alias,
    flags: options.flags || [],
    args: options.args || [],
    action
  }

}

export default task
