import collectObjects from '../../utils/collect_objects'
import _ from 'lodash'

const queueFiles = collectObjects('queues/*')

const _getQueue = (namespace) => {

  const config = _.find(queueFiles, { namespace })

  if(!config) throw new Error('invalid queue')

  const queue = require(config.filepath).default

  if(!queue) throw new Error('invalid queue')

  return queue

}

export const queueAdd = async (namespace, jobString) => {

  const queue = _getQueue(namespace)

  const job = JSON.parse(jobString)

  await queue.enqueue(null, null, job)

}

export const queueClean = async (namespace) => {

  const queue = _getQueue(namespace)

  await queue.clean('active')

  await queue.clean('wait')

  await queue.clean('delayed')

  await queue.clean('failed')

  await queue.clean('completed')

}

export const retryJob = async(namespace, job_id) => {

  const queue = _getQueue(namespace)

  const job = await queue.getJob(job_id)

  await job.retry()

}
