import register from 'babel-register'
import path from 'path'

register({
  presets: [
    'babel-preset-es2015',
    'babel-preset-react',
    'babel-preset-stage-0'
  ],
  plugins: [
    'transform-promise-to-bluebird',
    ['transform-runtime', { polyfill: false }],
    ['module-resolver', {
      'alias': process.env.APPS.split(',').reduce((aliases, app) => {
        aliases[app] = path.resolve('apps',app,'src','server.js')
        return aliases
      }, {})
    }]
  ],
  sourceMaps: 'inline'
})
